# Architecture Decision Records

|Requirement|Original Text|Decision|
|-----------|-------------|--------|
|IDM.PCM.CLOUD.00001|The cPCM MUST be designed in a way so that one cPCM instance is to be used by a single personal user. One cPCM instance MUST NOT be shared by multiple users.|The req was modified because a deep tenancy was integrated via deployment|
|IDM.PCM.CLOUD.00004|The aries mediator service MUST be used as the foundation for the mediator service for W3C functionality.|Aries stopped support, therefore a new one was developed|
|IDM.PCM.CLOUD.00006|To simplify the deployment a Kubernetes Operator MUST be developed to support an easier deployment for multi tenancy purposes. The operator MUST ensure that instances are reused, shut down etc.|This req was modified in cause of the deep tenancy. Operator was just inserted for plugin handling.|
|IDM.PCM.CLOUD.00007|To have multiple instances of the Cloud PCM can result in very big resource consumption. For this purpose, the architecture MUST be planned in a way that instances per user are less required or just hosted when a user is actively using it. E.g., serverless functions or by bootstrapping postgres database storage just in time when a credential for a user is received or must be presented or bootstrapping a OCM microservice just, when an attestation is required. Main goal of this requirement is to keep the operational costs as low as possible.|We deployed it in a standard way, because deep multi tenancy. Basic Proctection is always a cluster. All services are stateless so, podscaler can scale down an up to the minimum.|
|IDM.PCM.CLOUD.00014|The cPCM MUST provide a web interface based react native for browser-based applications. All functions available to the PCM user MUST be available via this web interface (except those which are not applicable such as camera scanning and NFC).| Just react was used, and all functions of pcm mobile are not applicable on web|
|IDM.PCM.CLOUD.00019| All interfaces from the PCM to the cPCM backend MUST be implemented as didcomm v2 messages. For instance: List Credentials, Delete Credential, Request Credential etc. The protocol MUST NOT reflect OCM protocols 1:1. e.g., List Connection or List Proofs. The cPCM Backend MUST encapsulate this for a UX by creating an integration layer which speaks an simplified didcomm v2 protocol for notification, consent and remote control. The developed didcomm protocol has to be defined as an architecture diagram and documented in the git repos similar to the Aries RFC documentation pattern.| Remote control was dropped in cause of changing EUDIW agenda about remote credentials, remote storage etc.
|IDM.PCM.CLOUD.00020|The cPCM MUST provide an interface for backup and restore of the cPCM data (which is stored in the wallet) based on the didcomm protocol and cPCM Rest API.| Backup protocol was designed, but backup in the cloud was not implemented in the mobile device in cause of changing EUDI Agenda|
|IDM.PCM.CLOUD.00021|To provide flexibility and interoperability between Applications and PCM Form Factors, the cPCM MUST provide interfaces for securely Exporting the personal wallet W3C content, as well as interfaces for securely Importing the personal wallet W3C content and restoring them in another application or PCM Form Factor. This includes the key material for using them. A scenario can be that a participant credential is transferred from the OCM W-Stack (which is linked to the cPCM), is transferred to a tablet to use the tablet within an secured area of a manufacturing side without internet access (but WIFI).|Export is not more allowed, especially for key material is it impossible to export something in the future from secure enclaves so all credentials which are exported are worthless then. Didcomm channel was created, but sync therefore dropped. |
|IDM.PCM.CLOUD.00026|The cPCM MUST support OIDC flows for login, such as DID SIOP and Authorization Code Grants by Standard IAM Systems. For a pairing of devices, a separate flow MUST be developed to initiate it.|OIDC Flow is realized by Keycloak, other flows can be enabled, but registration flow for creating credentials is not yet standardized|
|IDM.PCM.CLOUD.00027|For syncing the Wallets, Web Sockets MUST be used. Each didcomm message structure within the channel MUST be aligned with the technical lead.|Sync wallets was droppend because the EUDI decision goes in the direction of all on the device with secure enclaves (not the other way arround)|
|IDM.PCM.CLOUD.00030|The Cloud PCM MUST support Scale Down to 0 to avoid high operational costs.|Not more applicable with deep tenancy|
|




